#version 430 core

const float PI = 3.1415926535897932384626433832795;

const float length = 7.5;
const float amplitude = 0.1;


layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

uniform float lavaFlow;


vec3 distort(vec3 vertex){
	float radX = (vertex.x/length + lavaFlow) * 2.0 * PI;
	float radZ = (vertex.z/length + lavaFlow) * 2.0 * PI;
	float distortion  = amplitude * 0.5 * (sin(radZ) + cos(radX));
	return vertex + vec3(distortion, distortion / 75, distortion);
}

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

void main() {
	vert.normal_world = vec3(normalMatrix);
	vert.uv = uv;
	vec3 newPos = distort(position);
	vec4 position_world_ = modelMatrix * vec4(newPos, 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}
